using System.Text;
using Verse;
using RimWorld;

namespace rjw
{
	/// <summary>
	/// Comp for things
	/// </summary>
	public class CompThingBodyPart : ThingComp
	{
		/// <summary>
		/// Comp for rjw Thing parts.
		/// </summary>

		public string Size;					//eventually replace with below, maybe
		public float SizeBase;				//base size when part created, someday alter by operation
		public float SizeOwner = 0;			//modifier of 1st owner race body size
		public float EffSize;				//SizeBase x SizeOwner
		public string FluidType;			//cummies/milk - insectjelly/honey etc
		public float FluidAmmount;			//ammount of Milk/Ejaculation/Wetness
		public string Eggs;                 //for ovi eggs, maybe

		/// <summary>
		/// Thing/part size in labels, init comp on select
		/// </summary>
		public override string CompInspectStringExtra()
		{
			if (SizeOwner == 0)
				initComp();

			if (Size != "")
				return Translator.Translate("Size") + ": " + Size;
			else 
				return null;
		}

		/// <summary>
		/// Thing/part size in label
		/// </summary>
		public override string TransformLabel(string label)
		{
			if (Size != "")
				return label + " (" + Size + ")";

			return label;
		}

		/// <summary>
		/// Thing/part description + comp description
		/// </summary>
		public override string GetDescriptionPart()
		{
			//Log.Message("[RJW] CompTipStringExtra " + xxx.get_pawnname(Pawn) + " " + parent.def.defName);
			StringBuilder stringBuilder = new StringBuilder();
			if (SizeOwner == 0)
				initComp();
			if (parent.def.defName.ToLower().Contains("breasts"))
			{
				if (FluidType != "")
					stringBuilder.AppendLine("Milk: " + FluidType);
				if (FluidAmmount != 0)
				{
					stringBuilder.AppendLine("Amount: " + FluidAmmount.ToString("F2"));
				}
				if (Size != "")
					stringBuilder.AppendLine("Size: " + Size);
			}
			else if (parent.def.defName.ToLower().Contains("penis") || parent.def.defName.ToLower().Contains("vagina"))
			{
				if (FluidAmmount != 0)
				{
					if (FluidType != "")
						stringBuilder.AppendLine("Cum: " + FluidType);
					if (parent.def.defName.ToLower().Contains("penis"))
						stringBuilder.AppendLine("Ejaculation: " + FluidAmmount.ToString("F2") + "ml");
					if (parent.def.defName.ToLower().Contains("vagina"))
						stringBuilder.AppendLine("Wetness: " + FluidAmmount.ToString("F2"));
				}
				if (Size != "")
					stringBuilder.AppendLine("Size: " + Size);
			}
			else if (parent.def.defName.ToLower().Contains("anus"))
			{
				if (FluidType != "" && FluidAmmount != 0)
				{
					stringBuilder.AppendLine("Lube: " + FluidType);
					if (parent.def.defName.ToLower().Contains("anus"))
						stringBuilder.AppendLine("Wetness: " + FluidAmmount.ToString("F2"));
				}
				if (Size != "")
					stringBuilder.AppendLine("Size: " + Size);
			}
			else if (parent.def.defName.ToLower().Contains("ovi"))
			{
				if (Eggs != "")
					stringBuilder.AppendLine("Eggs: " + Eggs);
			}

			return stringBuilder.ToString();
		}

		/// <summary>
		/// fill comp data
		/// </summary>
		public void initComp(Pawn pawn = null)
		{
			double value = SexPartAdder.GenderTechLevelCheck(pawn);
			while (value == 0)
			{
				value = SexPartAdder.GenderTechLevelCheck(pawn);
			};

			{
				if (parent.def.defName.ToLower().Contains("breast"))
				{
					//TODO: replace with cups or not
					FluidType = "Milk";
					FluidAmmount = 0;
					SizeBase = (float)value;

					if (value < 0.05)
						Size = "Flat";
					else if (value < 0.20)
						Size = "Small";
					else if (value < 0.70)
						Size = "Average";
					else if (value < 0.80)
						Size = "Large";
					else if (value < 0.90)
						Size = "Huge";

					if (parent.def.defName == Genital_Helper.hydraulic_breasts.defName ||
						parent.def.defName == Genital_Helper.bionic_breasts.defName ||
						parent.def.defName == Genital_Helper.archotech_breasts.defName)
					{
						Size = "Average";
						SizeBase = 0.5f;
					}
				}
				else if (parent.def.defName.ToLower().Contains("penis"))
				{
					FluidType = "Cum";
					FluidAmmount = (float)value * 10 * 2;
					SizeBase = (float)value;

					if (value < 0.05)
						Size = "Micro";
					else if (value < 0.20)
						Size = "Small";
					else if (value < 0.70)
						Size = "Average";
					else if (value < 0.80)
						Size = "Big";
					else if (value < 0.90)
						Size = "Huge";

					if (parent.def.defName == Genital_Helper.hydraulic_penis.defName ||
						parent.def.defName == Genital_Helper.bionic_penis.defName ||
						parent.def.defName == Genital_Helper.archotech_penis.defName)
					{
						Size = "Average";
						SizeBase = 0.5f;
					}
				}
				else if (parent.def.defName.ToLower().Contains("vagina"))
				{
					FluidType = "Cum";
					FluidAmmount = (float)value * 10;
					SizeBase = (float)value;

					if (value < 0.05)
						Size = "Micro";
					else if (value < 0.20)
						Size = "Tight";
					else if (value < 0.70)
						Size = "Average";
					else if (value < 0.80)
						Size = "Loose";
					else if (value < 0.90)
						Size = "Gaping";

					if (parent.def.defName == Genital_Helper.hydraulic_vagina.defName ||
						parent.def.defName == Genital_Helper.bionic_vagina.defName ||
						parent.def.defName == Genital_Helper.archotech_vagina.defName)
					{
						Size = "Average";
						SizeBase = 0.5f;
					}
				}
				else if (parent.def.defName.ToLower().Contains("anus"))
				{
					FluidType = "";
					FluidAmmount = 0;
					SizeBase = (float)value;

					if (value < 0.05)
						Size = "Micro";
					else if (value < 0.20)
						Size = "Tight";
					else if (value < 0.70)
						Size = "Average";
					else if (value < 0.80)
						Size = "Loose";
					else if (value < 0.90)
						Size = "Gaping";

					if (parent.def.defName == Genital_Helper.hydraulic_anus.defName ||
						parent.def.defName == Genital_Helper.bionic_anus.defName ||
						parent.def.defName == Genital_Helper.archotech_anus.defName)
					{
						Size = "Average";
						SizeBase = 0.5f;
					}
				}
				else if (parent.def.defName.ToLower().Contains("tentacle"))
				{
					FluidType = "Cum";
					value *= 2;
					FluidAmmount = (float)value * 10 * 2;
					if (value < 0.05)
						Size = "Micro";
					else if (value < 0.20)
						Size = "Small";
					else if (value < 0.70)
						Size = "Average";
					else if (value < 0.80)
						Size = "Big";
					else if (value < 0.90)
						Size = "Huge";

					SizeBase = (float)value;
				}
				else if ((parent.def.defName.ToLower().Contains("ovi")))
				{
					Eggs = pawn?.kindDef?.label ?? "";
					Size = "";
					SizeBase = 0.5f;
					FluidType = ThingDefOf.InsectJelly.label;
					FluidAmmount = 0;
				}

				SizeOwner = pawn?.BodySize ?? 1.0f;
				EffSize = SizeOwner * SizeBase;
			}
		}
	}
}